    module types
      use globalvalues
      use precisions
!---------------------------------------------------------------------------------------------------------!
      type stats
        real (kind=rk) :: mean(numyears)
        real (kind=rk) :: sdev(numyears)
        real (kind=rk) :: skew(numyears)
        real (kind=rk) :: kurt(numyears)
        real (kind=rk) :: min(numyears)
        real (kind=rk) :: max(numyears)
      end type stats

!---------------------------------------------------------------------------------------------------------!
      type seriesstats
        type (stats) :: con
        type (stats) :: coninwork
        type (stats) :: conoutofwork
        type (stats) :: eqcon
        type (stats) :: ass
        type (stats) :: earn
        type (stats) :: inc
        type (stats) :: statepen
        type (stats) :: db, dc
        type (stats) :: guarcred
        type (stats) :: savcred
        type (stats) :: dcflowval
        type (stats) :: dcstockval
        type (stats) :: leis
        type (stats) :: claim
        type (stats) :: unemp
        type (stats) :: licon
        type (stats) :: logcon
        type (stats) :: logearn
        type (stats) :: loginc
        type (stats) :: totass
        type (stats) :: utility
        type (stats) :: ft
        type (stats) :: pt
        type (stats) :: grossinc
        type (stats) :: hhcoup
        type (stats) :: hhman
        type (stats) :: hhwoman
        type (stats) :: hhdead
        type (stats) :: default        
        type (stats) :: assStart
        type (stats) :: cashPaths
        type (stats) :: housingPaths      
        type (stats) :: sdf        
        type (stats) :: shockDec
        type (stats) :: cashInterest
        type (stats) :: housingCG      
        type (stats) :: housingYield        
        type (stats) :: mortgage
        
      end type seriesstats


!!---------------------------------------------------------------------------------------------------------!
!!---------------------------------------------------------------------------------------------------------!


 end module types

