    subroutine vfi(points, allearnings, ar1pmat,  assgrid, dcgrid, pengrid, housgrid, opt_realised, policy, exval, &
        sdffail, sdffailprop,failbyyear, failpropbyyear)

      use globalvalues
      use routines_specific
      use routines_generic
      use pension
      use precisions

      implicit none



! Arguments
      type (grids), intent (in) :: points
      real (kind=rk), intent (in) :: allearnings(workChoices, points%ar1by4, points%numyears)
      real (kind=rk), intent (in) :: assgrid(points%ass, points%numyears+1)
      real (kind=rk), intent (in) :: pengrid(points%pen), housgrid(points%housPoints, (65-19):points%numyears)
      real (kind=rk), intent (in) :: dcgrid(points%dc, claimAge-19)
      real (kind=rk), intent (in) :: ar1pmat(points%ar1by4, points%ar1by4, points%numyears)
      type(typeopt_realisations), intent(in)  :: opt_realised
      type (policy_funcs), intent (inout) :: policy
      type (val_funcs), intent (inout) :: exval
      integer, intent (out) :: sdffail(4)
      real (kind=rk), intent (out) :: sdffailprop(4)
      integer, intent(out) :: failbyyear(points%numyears, 4)
      real (kind=rk), intent(out) :: failpropbyyear(points%numyears, 4)

!Indexes
      integer :: ixtoday, ixlab, ixdcchoice, ixassnode, ixpenpoint, ixar1node, ixdcnode, ixhousPoint


! For program
      real (kind=rk) :: tomVal_pre(points%ass, points%dc, points%ar1by4, 3)
      real (kind=rk) :: tomMu_pre(points%ass, points%dc, points%ar1by4, 3)
      real (kind=rk) :: tomVal_post(points%ass, points%pen,points%ar1, 3)           
      real (kind=rk) :: tomMu_post(points%ass, points%pen,points%ar1, 3)             

      real (kind=rk) :: todaydcsave_array(workChoices, points%numdcch)
      type (utilityparams) :: params


! For use during iteration
      real (kind=rk) :: optimalc
      real (kind=rk) :: cashonhand
      real (kind=rk) :: nextperiodasset

      real (kind=rk) :: todaygrossinc
      real (kind=rk) :: todaygrossinclessdc, todaygrossearnlessdc
      real (kind=rk) :: todaynetinclessdc
      real (kind=rk) :: todaynetinclessdcwithben

       
      real (kind=rk) :: values(points%numdcch)
      real (kind=rk) :: cons(points%numdcch)
      type (typetomstates) :: tomstates(points%numdcch)    
      type (typetomstates) :: tomstates_opt  
      type (typetomvalfuncs) :: tomvalfuncs
      type (typetodayinfo) :: todayinfo
                  
      real (kind=rk) :: todayearn
      real (kind=rk) :: todaypension
      real (kind=rk) :: cash
      real (kind=rk) :: tompmat(points%ar1by4)
      type (typetomgrids) :: tomgrids
      logical :: possiblechoice(points%numdcch)
      real (kind=rk) :: todayexvalprime
      real (kind=rk) :: todaymargut

      integer :: todayage
      integer :: bestdisc(1)
      real (kind=rk) :: timestart, timeend
      
! Utility function parameters
      integer :: leisuretoday

! For SDF
!Multidimensions
      real (kind=rk) :: sdf_pre(points%ass, points%dc,  points%ar1by4,points%numhhcomp, claimAge-19)
      real (kind=rk) :: sdf_post(points%ass,  points%pen, points%ar1,points%numhhcomp, (claimAge-19+1):points%numyears)
      integer  :: licon_pre(points%ass, points%dc, points%ar1by4,points%numhhcomp, claimAge-19)
      integer  :: licon_post(points%ass, points%pen, points%ar1,points%numhhcomp, &
        (claimAge-19+1):points%numyears)

! Not yet sorted
      real (kind=rk) :: forderiv1
      real (kind=rk) :: forderiv2
      logical :: working         
      real (kind=rk) :: todayDCSave      
      integer :: maxDCNodeForLoop, maxPenForLoop 
      real (kind=rk) :: guess
      logical :: doGuess

      logical :: newar1,newdc
      character (80) :: path_in
      character (80) :: path_out    
      real (kind=rk) :: dcpotforannuit
      logical :: unemployed
      real (kind=rk) :: todayunemppayment
      real (kind=rk) :: tomGuess(points%ass, points%dc, points%ar1by4,points%numhhcomp, points%numdcch) 
      
      
      real (kind=rk) :: assetforassettest
      integer :: ixhaveclaimed
      logical :: haveclaimed 
      real (kind=rk) :: temp                       
      real (kind=rk) :: intdctime, inttimeend, inttimestart
      integer :: ixhhcomp
      real (kind=rk) :: upperbound
      real (kind=rk) :: unconsumed
      real (kind=rk) :: scratchrk, cashForAssetTest, scratchhousing, interestForTax, interest, margR
      integer :: maxHousPoint,        lowerar1node, uppar1node, nextAr1, lowerloc_hous, scratch
      real (kind=rk) ::    valFuncForDCInt(points%ass, points%dc),     muForDCInt(points%ass, points%dc)           
      integer :: ar1ForQuant, nearestAr1Quant, lowerAr1Quant
      real (kind=rk) :: interest_up
      integer :: numhhcompsToRunThrough, numhhcompsToRunThrough1
      
      real (kind=rk) :: liqShare
!New; possibly to be moved to a new subroutine

       real (kind=rk) ::  nextperioddc, conttocontvalue,expecvalue
       integer :: ixquad,ixassnode2, ixcumulnode2,ixclaimchoice2, ixlab2, ixdcchoice2,ixpenpoint2,numpenpoints, ixhhcomp2
       
       !For the tax function
       real (kind=rk) :: manshare
       
       real (kind=rk) :: lowerbound
       
       ! scratch
       integer :: TID,  OMP_GET_THREAD_NUM, OMP_GET_NUM_THREADS
! -----------------------------------------------------------------!
! End of declarations
! -----------------------------------------------------------------!

    callingFromVFI = .true.

!Set the parameters
      params = points%params

! -----------------------------------------------------------------!
! Allocations
! -----------------------------------------------------------------!
allocate (tomgrids%ass(points%ass))
allocate (tomgrids%dc(points%dc))
allocate (tomgrids%pen(points%pen))

allocate (tomvalfuncs%val_ar1Int_pre_adc(points%ass, points%dc, 3))
allocate (tomvalfuncs%eval_pre_adlq(points%ass,3,workChoices, points%numdcch))
allocate (tomvalfuncs%val_post_apc(points%ass, points%pen, 3))

allocate (tomvalfuncs%mu_arInt_pre_adc(points%ass, points%dc, 3))
allocate (tomvalfuncs%linEmu_pre_adlq(points%ass,3,workChoices, points%numdcch))
allocate (tomvalfuncs%mu_post_apc(points%ass, points%pen, 3))
allocate (tomvalfuncs%linEmu_post_ap(points%ass, points%pen))


!------------------------------------------------------------!
! Set terminal value function to 0
!------------------------------------------------------------!
! In reality we could set exval%post to anytyhing as its multiplied by zero
    
    exval%post(:,  :, :,:, :,  points%numyears+1) = 0
    exval%mu_post(:,  :, :,:, :,  points%numyears+1) = 1
!------------------------------------------------------------!
!------------------------------------------------------------!

!For printing, this may go at some stage
 call getpaths(path_in, path_out)
 
 todayinfo%dcalreadyintegrated = points%integrateoutsideoptimisation     
!
! -----------------------------------------------!
! Start cycling through time
! -----------------------------------------------!
      do ixtoday = points%numyears, 1, -1
      
          

    
      call cpu_time(timestart)
      
        todayage = ixtoday + 19
        todayinfo%yearsFrom2002 = opt_realised%yob  + todayage - 2002
        todayinfo%ixage = todayage
        todayinfo%ixtoday = ixtoday
        todayinfo%numkids = points%numkids(ixtoday)                            
        
        tomgrids%ass = assgrid(:, ixtoday+1)
        tomgrids%pen = pengrid

        if (todayage.gt.64) then 
            maxHousPoint = points%housPoints
             lowerar1node = 1
             uppar1node = points%ar1
        else
            maxHousPoint = 1
            lowerar1node = points%lowerar1nodeforint
            uppar1node = points%upperar1nodeforint
        end if     
        
        
        
        do ixHousPoint = 1, maxHousPoint, 1
        todayinfo%ixhouspoint = ixHousPoint
        
        !!! 
        ! Get tomorrow's value function and marginal utility 63 and before. And 65 and after.
        ! Continuation vfunc and mu as a function of (assets tomorrow, pensin, ar1shock and hhcomp )at 64 depends on assets today as that tells us which 
        ! asset node to transit to. So I defer that to later when I loop through assets

        if (todayage.lt.claimAge) then
          tomgrids%dc = dcgrid(:, ixtoday+1)
          tomVal_pre = exval%pre(:, :, :, :, ixtoday+1) !This is 4-dimen. Over assets, dcnode,  ar1shocks, hhcom   
          tomMu_pre = exval%mu_pre(:, :, :, :, ixtoday+1) !This is 4-dimen. Over assets, dcnode,  ar1shocks, hhcom             
        else if (todayage.gt.claimAge)  then   
          tomVal_post = exval%post(:,  :, :,ixHousPoint, :, ixtoday+1) !we remain at the same ixHousPoint for ever more
          tomMu_post = exval%mu_post(:,  :, :,ixHousPoint, :, ixtoday+1) !we remain at the same ixHousPoint for ever more
        end if
               
        if (todayage.gt.claimAge) then
                 haveclaimed = .true.
                 maxDCNodeForLoop = 1
                 maxPenForLoop = points%pen
        else
                 haveclaimed = .false.
                 maxDCNodeForLoop = points%dc
                 maxPenForLoop = 1
        end if


        intdctime = 0.0_rk
       
        call setparamsthisyear(points%numyears,points%numeqkids(ixtoday), ixtoday, todayage, params)    
 
! -----------------------------------------------!
! Start cycling through other states
! -----------------------------------------------!
! First one to see whats max hhcomp state for this year (if can'tbe dead don't go through it) 
if (todayage.lt.points%firstageatwhichdeath) then
    numhhcompsToRunThrough = 1
else 
    numhhcompsToRunThrough = points%numhhcomp
end if     

! Next see whats max hhcomp state for next year (if can't be dead don't integrate) 
if (todayage.lt.(points%firstageatwhichdeath-1)) then
    numhhcompsToRunThrough1 = 1
else 
    numhhcompsToRunThrough1 = points%numhhcomp
end if     


    
do ixhhcomp = 1,numhhcompsToRunThrough !points%numhhcomp ! 
       params%equivscaleinv =  params%equivscaleinvvec(ixhhcomp)
       params%equivscale = 1.0_rk/  params%equivscaleinv 
       todayinfo%ixhhcomp = ixhhcomp
                                           
     do ixar1node = lowerar1node, uppar1node, 1

      todayinfo%shockDecile = -bigdp
      
      !!!!
      ! Tomorrow's value function if retired - we stay at today's ixar1node
      !!!!
      if (todayage.gt.lastWorkAge) then     
           tomvalfuncs%val_post_apc = tomVal_post(:, :,ixar1node, :)
           tomvalfuncs%mu_post_apc= tomMu_post(:, :,ixar1node, :)      
           
      !!!!       
      ! Expected marginal utility tomorrow
      !!!!                   
          if ((todayage.ge.claimAge).and.(todayage.ne.(numyears+19))) then
            do ixassnode2 = 1, points%ass 
                do ixpenpoint2 = 1, points%pen           
                    tomvalfuncs%linEmu_post_ap(ixassnode2, ixpenpoint2)    =    margfelicity_inv(     &
                    points%survprobs3way(todayinfo%ixhhcomp, 1, todayinfo%ixtoday)*tomvalfuncs%mu_post_apc(ixassnode2,ixpenpoint2, 1) +  & 
                    points%survprobs3way(todayinfo%ixhhcomp, 2, todayinfo%ixtoday)*tomvalfuncs%mu_post_apc(ixassnode2,ixpenpoint2, 2) + &
                    points%survprobs3way(todayinfo%ixhhcomp, 3, todayinfo%ixtoday)*tomvalfuncs%mu_post_apc(ixassnode2,ixpenpoint2, 3) ,params)
                end do
            end do    
         else if (todayage.eq.(numyears+19)) then
             tomvalfuncs%linEmu_post_ap(:, :)  = -bigdp !Won't be using this in final year - set to -bigdp as a check
        end if        !  if (todayage.ge.claimAge) then
          
           
      end if
                            
      newar1 = .true.


      if (todayage.le.claimAge) then
        if ((ixar1node.le.points%ar1).or.((ixar1node.gt.points%ar1by2).and.(ixar1node.le.points%ar1by3))) then
            unemployed = .false.
        else            
            unemployed = .true.
        end if
      end if
      
      ! Get shockDecile
      if (todayage.gt.claimAge) then
            unemployed = .false.
            
            ! Get quantile
            if (ixar1node.le.points%ar1)                                          ar1ForQuant = ixar1node
            if ((ixar1node.gt.points%ar1).and.(ixar1node.le.points%ar1by2))       ar1ForQuant =  ixar1node - points%ar1
            if ((ixar1node.gt.points%ar1by2).and.(ixar1node.le.points%ar1by3))    ar1ForQuant = ixar1node - points%ar1by2                                        
            if ((ixar1node.gt.points%ar1by3))                                     ar1ForQuant =  ixar1node - points%ar1by3                          
            
            call findingridr(points%popEarQuantsAt64, points%ar1, allearnings(2, ar1ForQuant, 64-19), nearestAr1Quant, lowerAr1Quant)  ! What were earnings at age 64
            todayinfo%shockDecile = 10* real(nearestAr1Quant, rk)/real(points%ar1, rk)            
      end if
      
       call checkShockDecile

     
      do ixdcnode = 1, maxDCNodeForLoop, 1 
        newdc = .true. 
         do ixpenpoint = 1, maxPenForLoop , 1            
                if (ixhhcomp.eq.1) then
                    todaypension = pengrid(ixpenpoint)
                else
                    todaypension = pengrid(ixpenpoint)*points%penpropinherit
                end if
                

! -------------------------------------------------------------------------!
! Get prob dist over tomorrow's earnings shock
! and then integrate tomorrow's value function with respect to those shocks
! -------------------------------------------------------------------------!
                      if ((newar1) .or. (newdc) ) then 
                      
                          if ((newar1).and.(.not.(newdc))) then ! This is a simple check as the integration is first over ar1 then over dc
                            write(*,*) 'Error in vfi - in integration'
                            stop            ! We only go into each routine when they're sepeartely new
                          end if            ! ar is first. If we had a new ar1 and no newdc then the value function in the maximisation 
                                            ! would be an old one. The ordering of the loops mean this shouldn't happen. But this is just in
                                            ! case of any later changes this will catch the error
                                            
                                        
                      call cpu_time(inttimestart)       
                      !These only need to be updated when there is a newar1 shock 
                      if (newar1) then 
                                 
                            if (todayage.lt.claimAge) then
                              tompmat = ar1pmat(ixar1node, :, min((ixtoday+1),points%numyears))
                              if (sum(tompmat).lt.0.999_rk) then 
                                    write(*,*) 'Error in  vfi, probabilities not adding up to 1' 
                                    stop
                              end if 

                                tomvalfuncs%val_ar1Int_pre_adc = getexpoverar1(points, tomVal_pre, tompmat,  points%lowerar1nodeforint, points%upperar1nodeforint)
                                tomvalfuncs%mu_arInt_pre_adc = getexpoverar1(points, tomMu_pre, tompmat,  points%lowerar1nodeforint, points%upperar1nodeforint)
                                
                            end if                    

    ! -------------------------------------------------------------------------!
    ! Get array of savings for each labour/dc choice combination
    ! -------------------------------------------------------------------------!
                            call getsaveamounts(points, allearnings(:,ixar1node,ixtoday), points%alldcchoice, &
                              todaydcsave_array)
                            newar1 = .false.
                        end if !if ((newar1) .or (ixssthischip.eq.1)) then 
                        
                        if ((newdc) .and.&
                            (todayage.lt.claimAge).and.&
                            (.not.(haveclaimed)).and.(todayinfo%dcalreadyintegrated)) then 
                        newdc = .false.     

!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(ixassnode2, ixhhcomp2, ixlab2, ixdcchoice2, expecvalue)
                        do ixhhcomp2 = 1, numhhcompsToRunThrough1, 1
                        valFuncForDCInt =  tomvalfuncs%val_ar1Int_pre_adc(:,:, ixhhcomp2)
                        muForDCInt = tomvalfuncs%mu_arInt_pre_adc(:,:, ixhhcomp2)
                        
                        do ixassnode2 = 1,points%ass, 1                            
                        do ixlab2 = 1,workChoices,1
                        do ixdcchoice2 = 1, points%numdcch,1
                        
                        if  ((.not.((unemployed).and.(ixlab2.ne.1) )).and.&
                            (.not.((todayage.ge.64).and.(ixlab2.ne.1))).and.&
                            (.not.((ixlab2.eq.1).and.(ixdcchoice2.ne.1)))&                                                                                 
                            ) then 
                              
                                  !---------------------------------------!   
                                  ! Get expected value function
                                  !---------------------------------------!   
                                    
                                  expecvalue = &
                                  getexpoverdc(points, tomgrids,valFuncForDCInt,dcgrid(ixdcnode, ixtoday),todaydcsave_array(ixlab2, ixdcchoice2), &
                                            assgrid(ixassnode2,ixtoday+1), ixhhcomp2)
                                  
                                  tomvalfuncs%eval_pre_adlq(ixassnode2,ixhhcomp2,ixlab2, ixdcchoice2) = expecvalue                                                                
                                  
                                  
                                  !---------------------------------------!   
                                  ! Get expected inverte marginal utility
                                  !---------------------------------------!   
                                  
                                  expecvalue = &
                                  getexpoverdc(points, tomgrids,muForDCInt,dcgrid(ixdcnode, ixtoday),todaydcsave_array(ixlab2, ixdcchoice2), &
                                            assgrid(ixassnode2,ixtoday+1), ixhhcomp2)
                                  
                  
                                    
                                    ! Need to make an adjustment for negative marginal utility, which might happen with extrapoliation
                                    if ((dcgrid(ixdcnode, ixtoday) + todaydcsave_array(ixlab2, ixdcchoice2)).gt.dcgrid(points%dc, ixtoday+1)) then
                                        tomvalfuncs%linEmu_pre_adlq(ixassnode2,ixhhcomp2,ixlab2, ixdcchoice2) = bigdp
                                    else
                                        tomvalfuncs%linEmu_pre_adlq(ixassnode2,ixhhcomp2,ixlab2, ixdcchoice2) = margfelicity_inv(expecvalue ,params)   ! Inversion
                                    end if
                                                           
                              end if  
                              end do
                              end do
                              end do
                              end do
!$OMP END PARALLEL DO                              

                             
                              end if !if ((newdc) .or (ixssthischip.eq.1)) then 
                             call cpu_time(inttimeend)
                            intdctime = intdctime + inttimeend - inttimestart
                            end if !if ((newar1) .or. (newdc) .or (ixssthischip.eq.1)) then 


!$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(TID, ixassnode, todayinfo, ixdcchoice, possiblechoice, values, cons, todayearn, working, todayDCSave, todayunemppayment,  tomstates, dcpotforannuit,  assetforassettest,  todaygrossinc, todaygrossinclessdc, todaygrossearnlessdc, manshare, todaynetinclessdc, todaynetinclessdcwithben, cashonhand, upperbound, optimalc, bestdisc, tomstates_opt, unconsumed, todaymargut, nextperiodasset, forderiv1, forderiv2, todayexvalprime, interest, interestForTax)
          do ixassnode = 1, points%ass, 1
         !TID = OMP_GET_THREAD_NUM()

                    !Set today info
                    todayinfo%ixassnode = ixassnode 
                    todayinfo%ixdcnode = ixdcnode
                    todayinfo%ixar1node = ixar1node   
                    todayinfo%ixpenpoint = ixpenpoint                   
                    todayinfo%dcalreadyintegrated = points%integrateoutsideoptimisation     
                    todayage = ixtoday + 19
                    todayinfo%ixage = todayage
                    todayinfo%ixtoday = ixtoday
                    todayinfo%numkids = points%numkids(ixtoday)                            

                                         
                    call setTodayLeverageAndOver65(todayinfo, points)
                    
                    
                  if (todayage.lt.64) then        
                        todayinfo%housingIfOver65 = 0.0_rk   
                                                
                  else if (todayage.eq.claimAge) then                                               
                        liqShare = getLiqShare(points, todayinfo%ixage, todayinfo%over65, assgrid(ixassnode, ixtoday) )
                        todayinfo%housingIfOver65 =  (1.0_rk - liqShare) * assgrid(ixassnode, ixtoday)                                          
                  else
                        todayinfo%housingIfOver65 = housgrid(ixhouspoint, ixtoday)                  
                  end if
                  
                  
                todayinfo%statepen = statepen(points, todayage,opt_realised, todayinfo%shockDecile, todayinfo)
                todayinfo%db = db(points, todayage,opt_realised, todayinfo%shockDecile, todayinfo)
                    
                 
                  
                !!!! 
                !! If we're age 64, get the continuation value functions. For all other time periods, I do this at the towards the start of the time loop
                !! But at this age, the continuation value function depends on current asset node as that tells us which housing state to transit to
                !!!!                                         
                 if (todayage.eq.lastWorkAge) then    
                      if (ixar1node.le.points%ar1)                                          nextAr1 = ixar1node
                      if ((ixar1node.gt.points%ar1).and.(ixar1node.le.points%ar1by2))      nextAr1 =  ixar1node - points%ar1
                      if ((ixar1node.gt.points%ar1by2).and.(ixar1node.le.points%ar1by3))    nextAr1 = ixar1node - points%ar1by2                                        
                      if ((ixar1node.gt.points%ar1by3))                                    nextAr1 =  ixar1node - points%ar1by3                           
                        tomvalfuncs%val_post_apc      = exval%post(:,  :, nextAr1,ixassnode, :, ixtoday+1)   !ixassnode here tells us which housing node point we'll be on later    
                        tomvalfuncs%mu_post_apc     = exval%mu_post(:,  :, nextAr1,ixassnode, :, ixtoday+1)   !ixassnode here tells us which housing node point we'll be on later    
  
                      ! Expected linearised marginal utility tomorrow
                        do ixassnode2 = 1, points%ass 
                            do ixpenpoint2 = 1, points%pen           
                                tomvalfuncs%linEmu_post_ap(ixassnode2, ixpenpoint2)    =    margfelicity_inv(     &
                                points%survprobs3way(todayinfo%ixhhcomp, 1, todayinfo%ixtoday)*tomvalfuncs%mu_post_apc(ixassnode2,ixpenpoint2, 1) +  & 
                                points%survprobs3way(todayinfo%ixhhcomp, 2, todayinfo%ixtoday)*tomvalfuncs%mu_post_apc(ixassnode2,ixpenpoint2, 2) + &
                                points%survprobs3way(todayinfo%ixhhcomp, 3, todayinfo%ixtoday)*tomvalfuncs%mu_post_apc(ixassnode2,ixpenpoint2, 3) ,params)
                            end do
                        end do                                                         
                 end if

                call checkShockDecile

                     

! -------------------------!
! Reset various components
! -------------------------!

                      call reset
                   

! -----------------------------------------------!
! Now cycle through the discrete options, recording1
! consumption and value at each
! -----------------------------------------------!
                      do ixdcchoice = 1, points%numdcch, 1
                           todayinfo%ixdcchoice = ixdcchoice
                           
                           if ((todayage.lt.(claimAge + 1)).and.(.not.(working)).and.(ixdcchoice.ne.1)) then !If not working there's no point cycling through all the DC contributions - 1 is enough
                                   possiblechoice( ixdcchoice) = .false.
                                   values(  ixdcchoice) = -bigdp
                                   cons(  ixdcchoice) = -bigdp
                           else if ((todayage.ge.(claimAge + 1)).and.(ixdcchoice.ne.1)) then ! Can't put anything into DC fund now that claimed
                                   possiblechoice(  ixdcchoice) = .false.
                                   values(  ixdcchoice) = -bigdp
                                   cons(  ixdcchoice) = -bigdp
                           else
                                   possiblechoice( ixdcchoice) = .true.
          
                                   
                            !! Set a guess for quick solution 
                            if ((todayage.gt.claimAge).and.(todayage.lt.95).and.(.not.(neverUseGuess))) then
                                guess = policy%c_post(ixassnode,  ixpenpoint, ixar1node,ixHousPoint, ixhhcomp, ixtoday + 1)
                                doGuess = .true.
                            else
                                doGuess = .false.
                            end if    
                                   
                                   
                        !------------!
                        ! Earnings
                        !------------!
                          if ((todayage.le.claimAge).and.(.not.(unemployed))) then
                                   todayearn = allearnings(2, ixar1node, ixtoday)
                                   working = .true.
                                   todayinfo%leistoday = 0
                                   todayinfo%ixleis = 2       
                                   todayDCSave = todaydcsave_array(2, ixdcchoice)                                                                                                 
                          else
                                   todayearn = 0.0_rk
                                   working = .false.
                                   todayinfo%leistoday = 2
                                   todayinfo%ixleis = 1 
                                   todayDCSave = 0.0_rk                                                                                                        
                          end if
   
                       
                         !------------!
                         ! Unemployment Benefit
                         !------------!
                          if ((unemployed).and.(todayage.lt.points%statepenage)) then
                             todayunemppayment = funcUnempPayment(points, todayinfo%numkids)         
                          else
                             todayunemppayment = 0.0_rk
                          end if
                          
                           tomstates(ixdcchoice)%windfall = 0.0_rk                           
                           dcpotforannuit = 0.0_rk
                   

                         !------------!
                         ! Get income
                         !------------!                            
                            
                            ! Gross income here does not include interest income                            
                            interest = getInterest(assgrid(ixassnode, ixtoday),points, todayinfo, cashForAssetTest, scratchhousing, nonHInterest= interestForTax)                                                          
                            
                            if (todayage.gt.claimAge) then
                               assetforassettest = cashForAssetTest
                            else
                               assetforassettest = cashForAssetTest+dcgrid(ixdcnode, ixtoday)
                            end if

                            todaygrossinc = points%uncondtrans + todayearn + todaypension +  todayinfo%statepen + todayinfo%db + todayunemppayment + interest
                            todaygrossinclessdc = todaygrossinc - todayDCSave                                                         
                            todaygrossearnlessdc = todayearn - todayDCSave
                           
                           
                            manshare = points%manshare(ixtoday)                                                                                     

                            if (noPenTaxAdv) then
                                !DC saving comes out of grosss income, then we subtract DC
                                todaynetinclessdc = netfamilyincome_new(todaygrossinc - todaypension,todayearn, interest, interestForTax,points%tax2005, manshare, todayage)  - todayDCSave + todaypension
                                if (todaynetinclessdc .le. 0_rk) then
                                    todaynetinclessdc = 0.0_rk
                                    todayDCSave = netfamilyincome_new(todaygrossinc -  todaypension,todayearn, interest, interestForTax,points%tax2005, manshare, todayage) + todaypension
                                end if
                                
                            else
                                todaynetinclessdc = netfamilyincome_new(todaygrossinclessdc,todaygrossearnlessdc, interest, interestForTax,points%tax2005, manshare, todayage)
                            end if
                            
                            
                            todaynetinclessdcwithben = todaynetinclessdc & 
                              + guarcred(points%pc,todaynetinclessdc,assetforassettest, todayage,ixhhcomp)&
                              + savcred(points%pc,todaynetinclessdc,assetforassettest, todayage,ixhhcomp) &
                              + taxben(todayinfo, points%tax2005)
                            
                            cashonhand = todaynetinclessdcwithben + assgrid(ixassnode, ixtoday) 
                            

                            tomstates(ixdcchoice)%cash = cashonhand
                                                    
                        !-----------------------------------!                                                        
                        ! Set pension stuff for next period    
                        !-----------------------------------!                                                                                        
                        if (todayage.lt.claimAge) then
                          tomstates(ixdcchoice)%dc = dcgrid(ixdcnode, ixtoday) + todayDCSave                                      
                          tomstates(ixdcchoice)%pen = pengrid(ixpenpoint)
                           
                        else if (todayage.eq.claimAge) then
                          tomstates( ixdcchoice)%windfall =(dcgrid(ixdcnode,ixtoday)+todayDCSave)*points%dclumpsumprop
                          
                          dcpotforannuit = points%oneminusdclumpsumprop*(dcgrid(ixdcnode,ixtoday)+ todayDCSave)
                          tomstates(  ixdcchoice)%dc = 0.0_rk				          
                          tomstates(  ixdcchoice)%pen = pension_dc(points, points%fairannuity(todayage - 19,ixhhcomp), todayage, dcpotforannuit)  
                          
                          
                        else if (todayage.ge.(claimAge + 1)) then                            
                             tomstates(ixdcchoice)%pen =  pengrid(ixpenpoint)    
                        end if                                                                                                     

                            if (0.1_rk.lt.(cashonhand)) then                                                          
                            todayinfo%ixdcchoice = ixdcchoice
                            upperbound = cashonhand
                            if (todayage.eq.64) then
                                  upperbound = upperbound -  todayinfo%housingIfOver65             
                            end if
            
                              if (upperbound .lt. 0.0_rk) then
                                    write(*,*) 'uppbound is negative in vfi'
                                    stop
                              end if


 
                              lowerbound = max(cashonhand - assgrid(points%ass, ixtoday), 0.01_rk)

                              values(  ixdcchoice) = getMax_fast(points, lowerbound, upperbound, guess, doGuess, optimalc,tomstates(ixdcchoice), tomgrids,tomvalfuncs,todayinfo, params)
                              
                              cons( ixdcchoice) = optimalc

                              ! Store the solution as a guess for tomorrow
                              if (todayage.le.64) tomGuess(ixassnode, ixdcnode, ixar1node,ixhhcomp, ixdcchoice) = optimalc                                                            
                              call checkValueFuncSign


   
                           else if (0.1_rk.ge.cashonhand) then
                              values( ixdcchoice) = -bigdp
                              cons(  ixdcchoice) = -bigdp
                            end if
                            end if ! possiblechoice 
                      end do !ixdcchoice ixdcchoice = 1, points%numdcch, 1

                      
                      
! Having cycled through the  options find which one is the best
                      bestdisc = maxloc(values, mask=possiblechoice)                      
                                            
                      optimalc = cons(bestdisc(1))
                      todayinfo%ixdcchoice = bestdisc(1) ! For SDF check below

                      if (optimalc.eq.-bigdp) then
                        write (*, *) &
                          'error in vfi - someone is being passed around optimization routine who shouldnt be'                            
                          stop
                      end if

                      
! Get marginal utility
                   todaymargut = margfelicity(optimalc, todayinfo%leistoday, params)
                      
                   if (todayage.le.claimAge) then
                        exval%pre(ixassnode, ixdcnode,  ixar1node,ixhhcomp, ixtoday) = values(bestdisc(1)) 
                        exval%mu_pre(ixassnode, ixdcnode,  ixar1node,ixhhcomp, ixtoday) = todaymargut                     
                        policy%c_pre(ixassnode, ixdcnode, ixar1node,ixhhcomp, ixtoday) = optimalc
                        policy%dc_pre(ixassnode, ixdcnode, ixar1node,ixhhcomp, ixtoday) = bestdisc(1)                                                                                                                           
                   else
                        exval%post(ixassnode,  ixpenpoint, ixar1node,ixHousPoint, ixhhcomp, ixtoday) = values(bestdisc(1)) 
                        exval%mu_post(ixassnode,  ixpenpoint, ixar1node,ixHousPoint, ixhhcomp, ixtoday) = todaymargut
                        policy%c_post(ixassnode,  ixpenpoint, ixar1node,ixHousPoint, ixhhcomp, ixtoday) = optimalc                 
                   end if

                end do  !ixass              
!$OMP END PARALLEL DO
            end do !ixpenpoint
          end do ! ixdcnode
    end do !ixar1node
end do !ixhhcomp


        end do !ixhousPoint
        
        call cpu_time(timeend) 
        if (.not.(solveForBeta)) then
        if ((.not.(points%nowiterating))) then !Don't want to do this at every iteration - only for the final answer
          write (*, '(i12)', advance = 'no') ixtoday
          write (*,'(f12.3)', advance = 'no') intdctime          
          write (*,'(f12.2)', advance = 'no') timeend - timestart
        end if
        end if !if (.not.(solveForBeta)) then

     
       

       
      end do !ixtoday
    

      
      callingFromVFI = .false.

      
      !Some deallocations
      deallocate (tomgrids%ass)
      deallocate (tomgrids%dc)
      deallocate (tomgrids%pen)
      deallocate (tomvalfuncs%val_post_apc)
      deallocate (tomvalfuncs%eval_pre_adlq)
      deallocate(tomvalfuncs%val_ar1Int_pre_adc)
      deallocate (tomvalfuncs%mu_post_apc)
      deallocate (tomvalfuncs%linEmu_pre_adlq)
      deallocate(tomvalfuncs%mu_arInt_pre_adc)
      deallocate (tomvalfuncs%linEmu_post_ap)
      
      
    contains
!---------------------------------------------------------------------------------------------------------!      
!---------------------------------------------------------------------------------------------------------!
      subroutine reset
        implicit none

        values = -bigdp
        cons = -bigdp
        possiblechoice = .false.
      end subroutine reset
!---------------------------------------------------------------------------------------------------------!      
!---------------------------------------------------------------------------------------------------------!
 

!---------------------------------------------------------------------------------------------------------!      
!---------------------------------------------------------------------------------------------------------!

      subroutine checkShockDecile

      !Check the shock percentile
                   if (todayage.le.claimAge) then
                        if (todayinfo%shockDecile .gt. 0.0_rk) then
                               write(*,*) 'error in vfi, shockDecile should be negative for  before claimAge'
                               stop
                        end if
                   else
                        if ((todayinfo%shockDecile.lt.0.0_rk).or.(todayinfo%shockDecile.gt.10.0_rk)) then
                               write(*,*) 'error in vfi, shockDecile should be between zero and 1'            
                               stop
                        end if       
                   end if
    end subroutine checkShockDecile
!---------------------------------------------------------------------------------------------------------!      
!---------------------------------------------------------------------------------------------------------!
                   
subroutine checkValueFuncSign
!                              !Do a check that the value function has the correct sign
      if (.not.(points%dontdovalfuncsigncheck).and.(.not.(points%worktorule))) then
      if ((values(ixdcchoice)*params%oneover1minusgamma).lt.0.0_rk) then
      
          write (*,*) 'error in vfi. Value function has wrong sign'
          write (*,*) 'value is', values(ixdcchoice)
          write (*,*) 'consumption is', optimalc
          write (*,*) 'next period asset is', nextperiodasset
          write (*,*) 'asset node', ixassnode 
          write (*,*) 'dc node', ixdcnode
          write (*,*) 'pen node', ixpenpoint
          write (*,*) 'ar1 node', ixar1node
          write (*,*) 'today', ixtoday   
          write (*,*) 'dc choice is', ixdcchoice            

          !For debugging
          values(ixdcchoice) = golden(points, 0.1_rk, upperbound, optimalc,tomstates(ixdcchoice), &
            tomgrids, tomvalfuncs,todayinfo, params)
          stop
       end if
       end if !if (.not.(dontdovalfuncsigncheck))
    end subroutine checkValueFuncSign




    end subroutine vfi

