    module developments
!      use precisions
!      use routines_generic
!      use types
!      use pension
      
!    contains

!      subroutine test(points)
!        implicit none
!        type (grids) :: points!
!        integer :: ix
!        real (kind=rk) :: preincome, gc, sc, pc, tot
!        
!        write(*,*) 'test is being called'
!        
!        open (unit=200, file= 'Y:\Cormac\preincome.txt', action='write')
!        open (unit=201, file='Y:\Cormac\guarcred.txt', action='write')
!        open (unit=202, file='Y:\Cormac\savcred.txt', action='write')
!        open (unit=203, file='Y:\Cormac\pencred.txt', action='write')
!        open (unit=204, file='Y:\Cormac\postincome.txt', action='write')
!        
!        do ix = 1, 500, 1
!          preincome = real(ix, rk) * 52.0_rk
!          
!          gc = guarcred(points,preincome, 0.0_rk, 60) 
!          sc = savcred(points,preincome,  0.0_rk, 60)
!          pc = gc + sc
!          tot = preincome + pc
!          
!          write(200,*) preincome/52.0_rk
!          write(201,*) gc/52.0_rk
!          write(202,*) sc/52.0_rk
!          write(203,*) pc/52.0_rk
!          write(204,*) tot/52.0_rk
!        
!        end do
!        
!
!      end subroutine test
!

!      subroutine checkquasi(min,max,xmax,assets,income,assvec,tomcumulgrid,valarray2d,cumulearn,leis,beta,gamma, &
!          expeta,ratedum,survprob)
!        use globalvalues
!        implicit none

!!Generic stuff
!!Arguments
!        real(kind=rk), intent (in) :: min
!        real(kind=rk), intent (in) :: max
!        real(kind=rk), intent (out) :: xmax

!!Stuff particular to my utility function
!        real(kind=rk), intent (in) :: assets
!        real(kind=rk), intent (in) :: income
!        real(kind=rk), intent (in) :: assvec(gridpoints)
!        real(kind=rk), intent (in) :: tomcumulgrid(cumulpoints)
!        real(kind=rk), intent (in) :: valarray2d(gridpoints,cumulpoints)
!        real(kind=rk), intent (in) :: cumulearn
!        integer, intent (in) :: leis
!        real(kind=rk), intent (in) :: beta
!        real(kind=rk), intent (in) :: gamma
!        real(kind=rk), intent (in) :: expeta
!        real(kind=rk), intent (in) :: ratedum
!        real(kind=rk), intent (in) :: survprob


!      end subroutine checkquasi

!A subroutine to test the DC simulation
!subroutine testdc
!  use globalvalues
!  implicit none
!  real(kind=rk) :: unifdrawsfordc(numyears,howmanysims)

!  call getunifdraws(numyears,howmanysims,numyears*howmanysims,126679852,unifdrawsfordc)


! end subroutine testdc

!    call getunifdraws(numyears,howmanysims,numyears*howmanysims,126679852,unifdrawsfordc)

!Get probability distribution over tomorrow's dc grid
!          call getdistovertomdc(cumulearn_today,dcgrid(dcnode_today,ixtoday),todaydcsave,todayearning,dcgrid(:,min( &
!            ixtoday+1,numyears)),dcpmattom)

!Get realised dcnode tomorrow
!First turn tomorrow's probability distribution into a cumulative distribution function
!          call pdftocdf(dcpoints,dcpmattom,dccdftom)

!And now use the realised uniform random number to find a dc point tomorrow
!          call findingridr(dccdftom,dcpoints,unifdrawsfordc(ixtoday,ixsims),scratch,lowerloc_dc)
!          dcnode_tom = lowerloc_dc + 1





!alldcfund_val(ixtoday,ixsims) = dcgrid(dcnode_today,ixtoday)*cumulearn_today + todaydcsave

!!!Old code:

! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!
!subroutine estimate
!  implicit none
!    integer, parameter :: numvartobeest = 2
!    real (kind=rk) :: xval(numvartobeest), lb(numvartobeest), ub(numvartobeest)
!    real (kind=rk) :: iw(numvartobeest + 5), w(30)
!    integer :: ifail
!    integer :: iuser
!    real (kind=rk) :: ruser 
!    real (kind=rk) :: finalmoment
!    real (kind=rk) :: rhobeg, rhoend
!    integer :: numcalls
!    logical, parameter :: doe04jyf = .false.
!    logical, parameter :: doe04jcf  = .true.
!    
!    
!    external :: E04JCP
!    points%nowestimating = .true.
!   
!   
!    
!    ifail = 0
!    xval(1) = points%params%beta
!    lb(1) = 0.8_rk
!    ub(1) = 1.2_rk    
!    
!    xval(2) = points%params%gamma
!    lb(2) = 0.1_rk
!    ub(2) = 2.0_rk 
!    
!    
!    if (doe04jyf) then
!    
!    call E04JYF(numvartobeest, 0, getmoments, lb, ub, xval, finalmoment, iw, (numvartobeest + 5), w, 30, iuser, ruser,ifail)
!    end if
!    
!    if (doe04jcf) then
!    rhobeg = 0.01_rk
!    rhoend = 0.0001_rk        
!    call E04JCF (getmoments, numvartobeest, 5, xval, lb, ub, rhobeg, rhoend, E04JCP, 200, finalmoment, &
!                numcalls, iuser, ruser, ifail)
!    end if
!    
!    write(*,*) finalmoment, xval
!    points%params%beta = xval(1)
!    points%params%gamma = xval(2)
!    points%nowestimating = .false.
!
!end subroutine estimate
!
!!! ---------------------------------------------------------------------------------------------------------!
!!! ---------------------------------------------------------------------------------------------------------!
!!! ---------------------------------------------------------------------------------------------------------!
!!! ---------------------------------------------------------------------------------------------------------!
!!
!subroutine getmoments(numvars, currentvals, moment, iuserdum, ruserdum, inform)
!  implicit none
!  
!  integer, intent(in) :: numvars
!  real (kind=rk), intent(in) :: currentvals(numvars)
!  real (kind=rk), intent(out) :: moment
!  integer, intent(in) :: iuserdum
!  real (kind=rk), intent(in) ::  ruserdum
!  integer :: inform
!  
!  inform = 1
!
!! Overwrite input points (starting value) with current value of argument
!        points%params%beta = currentvals(1)
!        points%params%gamma = currentvals(2)       
!        call solveandsim      
!        moment = ((120000 - alltypstats(1)%ass%mean(50))/120000)**2
!        write(*,*) currentvals, moment
!end subroutine getmoments
!!! ---------------------------------------------------------------------------------------------------------!
!! ---------------------------------------------------------------------------------------------------------!



    end module developments
